/*
    Aufgabe 3) Klassen und Objekte -- Vier Gewinnt

    Fortsetzung des "Vier gewinnt" Spiels aus Aufgabenblatt 5.
     
    Auch auf diese Aufgabe werden spätere Aufgabenblätter aufbauen, Sie sollten
    sie daher unbedingt lösen.
    
    Definieren Sie eine Klasse Spielfeld mit einem Konstruktor, der ein leeres
    Spielfeld erzeugt, und folgenden (nicht-statischen) Methoden:

    - int feld(int reihe, int spalte) gibt 0, 1, oder 2 zurück, je nachdem, ob
      das Feld besetzt ist und von wem.

    Folgende Methoden sind nicht-statische Varianten für Spielfeld der früher
    definierten statischen Methoden:

    - void spielstand()
    - Spielfeld zug(int spieler, int Spalte)
    - boolean sieg(int spieler)
    - int wert1(int spieler)
    - int wert(int spieler)
    - int negamax(int spieler, int tiefe)
    - int bester(int spieler, int tiefe)

    Das Spielfeld wird dabei noch immer so repräsentiert wie zuvor.

    Schreiben Sie eine Klasse Viergewinnt mit den Methoden

    - public static void spiel()
    - public static void spiel1(int tiefe)

    die für das Spielfeld und die Methoden dazu die Klasse Spielfeld benutzen.

    Zusatzfrage: Ist spiel1() bei gleicher Tiefe durch diese Änderung
    schneller oder langsamer geworden? Um wieviel?
    ****************************************************************************
*/
// TODO: Implementieren Sie hier die Klasse "Spielfeld"

// TODO: Implementieren Sie hier die Klasse "Viergewinnt"

public class Aufgabe3 {
    
    public static void main(String[] args) {
    }

    //**************************************************************************
    // In diesem File finden Sie Musterlösungen zu einigen Methoden aus
    // Aufgabenblatt4. Diese sollen Ihnen helfen die geforderte Funktionalität in
    // Aufgabenblatt5 zu realisieren.
    //**************************************************************************
    public static int[][] spielfeld(){
        return new int[6][7];
    }

    public static void spielstand(int[][] f){
        for(int y = f.length-1; y >= 0; y--){
            System.out.print("|");
            for(int x : f[y]){
                switch(x){
                    case 0:
                        System.out.print(" ");
                        break;
                    case 1:
                        System.out.print("x");
                        break;
                    case 2:
                        System.out.print("o");
                        break;
                }
            }
            System.out.println("|");
        }
        System.out.println("+-------+");
    }

    public static int[][] zug(int[][] f, int spieler, int spalte){
        if (spalte < 0 || spalte > 6){
            return null;
        }
        if (f[5][spalte] != 0){
            return null;
        }
        int r = 0;
        while(f[r][spalte] != 0){
            r++;
        }
        f[r][spalte] = spieler;
        return f;
    }

    public static boolean sieg(int[][] f, int spieler) {
        // first, check 4-in-a-row:
        for (int r = 0; r <= 5; r++) {
            int cont = 0;
            for (int c = 0; c <= 6; c++) {
                if (f[r][c] == spieler){
                    cont++;
                }
                else {
                    cont = 0;
                }
                if (cont == 4) {
                    return true;
                }
            }
        }

        // now, check 4-in-a-column:
        for (int c = 0; c <= 6; c++) {
            int cont = 0;
            for (int r = 0; r <= 5; r++) {
                if (f[r][c] == spieler){
                    cont++;
                }
                else{
                    cont = 0;
                }
                if (cont == 4) {
                    return true;
                }
            }
        }

        // then, check 4-in-a-positive-diagonal:
        for (int d = -2; d <= 3; d++) {
            int cont = 0;
            for (int r = 0; r <= 5; r++) {
                int c = r + d;
                if (c >= 0 && c <= 6) {
                    if (f[r][c] == spieler) {
                        cont++;
                    } else {
                        cont = 0;
                    }
                    if (cont == 4) {
                        return true;
                    }
                }
            }
        }

        // finally, check 4-in-a-negative-diagonal:
        for (int d = 3; d <= 8; d++) {
            int cont = 0;
            for (int r = 5; r >= 0; r--) {
                int c = d - r;
                if (c >= 0 && c <= 6) {
                    if (f[r][c] == spieler) {
                        cont++;
                    } else {
                        cont = 0;
                    }
                    if (cont == 4) {
                        return true;
                    }
                }
            }
        }
        return false;
    }


    //**************************************************************************
    // In diesem File finden Sie Musterlösungen zu einigen Methoden aus
    // Aufgabenblatt5. Diese sollen Ihnen helfen die geforderte Funktionalität
    // in Aufgabenblatt6 zu realisieren.
    //**************************************************************************
    public static int wert1(int[][] f, int spieler){
        int result = 0;
        for (int r = 0; r <= 5; ++r) {
            for(int c = 0; c <= 6; ++c) {
                for (int len = 2, weight = 1; len <=4; len++, weight*=100) {
                    boolean isRow = true, isColumn = true, isDiagP = true, isDiagN = true;
                    for(int i = 0; i < len; i++) {
                        if (c+i > 6 || f[r][c+i] != spieler) isRow = false;
                        if (r+i > 5 || f[r+i][c] != spieler) isColumn = false;
                        if (r+i > 5 || c+i > 6 || f[r+i][c+i] != spieler) isDiagP = false;
                        if (r-i < 0 || c+i > 6 || f[r-i][c+i] != spieler) isDiagN = false;
                    }
                    if (isRow) result += weight;
                    if (isColumn) result += weight;
                    if (isDiagP) result += weight;
                    if (isDiagN) result += weight;
                }
            }
        }
        return result;
    }

    public static int wert(int[][] f, int spieler){
        int opponent = spieler == 1 ? 2 : 1;
        return wert1(f, spieler) - wert1(f, opponent);
    }

    public static int negamax(int[][] f, int spieler, int tiefe){
        if(tiefe == 0){
            return wert(f,spieler);
        }
        int opponent = spieler == 1 ? 2 : 1;
        int bestMaxValue = Integer.MIN_VALUE;
        for(int i = 0; i <= 6; i++){
            if(zug(f,spieler,i) != null){
                int currentMaxValue;
                if(sieg(f,spieler)){
                    currentMaxValue = Integer.MAX_VALUE;
                }
                else{
                    currentMaxValue = -negamax(f,opponent,tiefe-1);
                }
                if(currentMaxValue > bestMaxValue){
                    bestMaxValue = currentMaxValue;
                }
                unzug(f,i);
            }
        }
        return bestMaxValue;
    }

    // Hilfsmethode
    private static int[][] unzug(int[][] f, int spalte){
        if(spalte < 0 || spalte > 6){
            return null;
        }
        if(f[0][spalte] == 0){
            return null;
        }
        int r = 0;
        while(r <= 5 && f[r][spalte] != 0){
            r++;
        }
        f[r-1][spalte] = 0;
        return f;
    }

    public static int bester(int[][] f, int spieler, int tiefe){
        int bestIndex = -1;
        int opponent = spieler == 1 ? 2 : 1;
        int bestMaxValue = Integer.MIN_VALUE;
        for(int i = 0; i <= 6; i++){
            if(zug(f,spieler,i) != null){
                int currentMaxValue;
                if(sieg(f,spieler)){
                    currentMaxValue = Integer.MAX_VALUE;
                }
                else{
                    currentMaxValue = -negamax(f,opponent,tiefe);
                }
                if(currentMaxValue > bestMaxValue){
                    bestMaxValue = currentMaxValue;
                    bestIndex = i;
                }
                unzug(f,i);
            }
        }
        return bestIndex;
    }

}


