//**************************************************************************
// In diesem File finden Sie Musterlösungen zu einigen Methoden aus 
// Aufgabenblatt5. Diese sollen Ihnen helfen die geforderte Funktionalität 
// in Aufgabenblatt6 zu realisieren.
//**************************************************************************
public static int wert1(int[][] f, int spieler){
	int result = 0;
	for (int r = 0; r <= 5; ++r) {
		for(int c = 0; c <= 6; ++c) {
			for (int len = 2, weight = 1; len <=4; len++, weight*=100) {
				boolean isRow = true, isColumn = true, isDiagP = true, isDiagN = true;
				for(int i = 0; i < len; i++) {
					if (c+i > 6 || f[r][c+i] != spieler) isRow = false;
					if (r+i > 5 || f[r+i][c] != spieler) isColumn = false;
					if (r+i > 5 || c+i > 6 || f[r+i][c+i] != spieler) isDiagP = false;
					if (r-i < 0 || c+i > 6 || f[r-i][c+i] != spieler) isDiagN = false;
				}
				if (isRow) result += weight;
				if (isColumn) result += weight;
				if (isDiagP) result += weight;
				if (isDiagN) result += weight;
			}
		}
	}  
	return result;
}

public static int wert(int[][] f, int spieler){
	int opponent = spieler == 1 ? 2 : 1;
	return wert1(f, spieler) - wert1(f, opponent);
}

public static int negamax(int[][] f, int spieler, int tiefe){
	if(tiefe == 0){
		return wert(f,spieler);
	}
	int opponent = spieler == 1 ? 2 : 1;
	int bestMaxValue = Integer.MIN_VALUE;
	for(int i = 0; i <= 6; i++){
		if(zug(f,spieler,i) != null){
			int currentMaxValue;
			if(sieg(f,spieler)){
				currentMaxValue = Integer.MAX_VALUE;
			}
			else{
				currentMaxValue = -negamax(f,opponent,tiefe-1);
			}
			if(currentMaxValue > bestMaxValue){
				bestMaxValue = currentMaxValue;
			}
			unzug(f,i);
		}
	}
	return bestMaxValue;
}

// Hilfsmethode
private static int[][] unzug(int[][] f, int spalte){
	if(spalte < 0 || spalte > 6){
		return null;
	}
	if(f[0][spalte] == 0){
		return null;
	}
	int r = 0;
	while(r <= 5 && f[r][spalte] != 0){
		r++;
	}
	f[r-1][spalte] = 0;
	return f;
}

public static int bester(int[][] f, int spieler, int tiefe){
	int bestIndex = -1;
	int opponent = spieler == 1 ? 2 : 1;
	int bestMaxValue = Integer.MIN_VALUE;
	for(int i = 0; i <= 6; i++){
		if(zug(f,spieler,i) != null){
			int currentMaxValue;
			if(sieg(f,spieler)){
				currentMaxValue = Integer.MAX_VALUE;
			}
			else{
				currentMaxValue = -negamax(f,opponent,tiefe);
			}
			if(currentMaxValue > bestMaxValue){
				bestMaxValue = currentMaxValue;
				bestIndex = i;
			}
			unzug(f,i);
		}
	}
	return bestIndex;
}

